# -*- coding: utf-8 -*-
"""
Script to export boundary condition nodes (BCN) and boundary condition nodestrings (BCS).
Needed modules: read_2dm_sms11.py (separate script)
"""

import read_2dm_sms11
import shapefile
import glob
import re
import numpy as np

smsFiles=glob.glob(r'c:\lzi\Projekty\DE_HydroAs\work\HydroAs_2dm'+r'\*.2dm')
for sms in smsFiles:
    p=read_2dm_sms11.read_sms_mesh(sms,True)

    f=open(sms,'r')
    lines=f.readlines()
    f.close()
    
    bcn=[]
    bcs=[]
    bcsv=[]
    countNS=1
    shpNamePre=sms.split('\\')[-1][:-4].replace(' ','_')
    outputFolder=r'c:\lzi\Projekty\DE_HydroAs\work\HydroAs_2dm\bcn_bcs'
    outputPath=outputFolder+'\\'+shpNamePre
    
    for line in enumerate(lines):
        l=line[1].strip()
        #Saving all BCN as list
        if l.startswith('BC_VAL N'):
            a=re.split(' +',l)
            if a[3]=='2':
                bcn.append([int(a[2]),int(a[3]),-9999])
            else:
                bcn.append([int(a[2]),int(a[3]),float(a[5])])
        #Saving all BCS as list
        elif l.startswith('BC_VAL S'):
            b=re.split(' +',l)
            prevLine=lines[line[0]-1]
            c=re.split(' +',prevLine)
            if b[2]==c[2]:
                for v in range(5,len(b)):
                    bcsv.append(b[v])
            else:
                bcsv=[]
                for v in range(2,len(b)):
                    if v <= 2:
                        bcsv.append(int(b[v]))
                    elif v==4:
                        pass
                    else:
                        bcsv.append(b[v])
            if bcsv not in bcs:
                bcs.append(bcsv)
    
    #Saving BCN as point shapefile               
    shpBCN=shapefile.Writer(shapeType=1)
    shpBCN.field('id_2dm','N')
    shpBCN.field('type','N')
    shpBCN.field('value','N',10,3)
    for j in bcn:
        index=np.where(p[1]==j[0])[0][0]
        shpBCN.record(j[0],j[1],j[2])
        shpBCN.point(p[2][index],p[3][index])              
    shpBCN.save(outputPath+'_bcn.shp')
                    
    #Saving BCS as line shapefile
    shpBCS=shapefile.Writer(shapeType=3)
    shpBCS.field('id','N')
    shpBCS.field('type','N')
    shpBCS.field('value','C',250)
    for h in bcs:
        value=", ".join(str(x) for x in h[2:])
        shpBCS.record(h[0],h[1], value)
        ndStr=p[6][h[0]-1]
        part=[]
        for nd in ndStr:
            index=np.where(p[1]==nd)[0][0]
            part.append([p[2][index],p[3][index]])
        shpBCS.line(parts=[part])     
    shpBCS.save(outputPath+'_bcs.shp')
